; Declarations of memory areas and functions
; for the nametable editor
; Copyright 2012 Damian Yerrick
;
; Copying and distribution of this file, with or without
; modification, are permitted in any medium without royalty provided
; the copyright notice and this notice are preserved in all source
; code copies.  This file is offered as-is, without any warranty.
;

.ifndef RAM_H
.define RAM_H

.macro DEBUG_CHECKPOINT
  sta $FF
.endmacro

OAM = $0200
SRAM_BGCHR = $6000
SRAM_BGCHR_END = $7000
SRAM_OBJCHR = $7000
SRAM_OBJCHR_END = $7800
SRAM_NT = $7800
SRAM_NT_END = $7C00
SRAM_PALETTE = $7F00

; play_game::screens

; main.s
SCREEN_CHRPICKER = 0
SCREEN_NTEDIT = 2

NUM_CHRMENU_ITEMS = 6
SCREEN_CHRMENUBASE = 4
SCREEN_CHRMENUEND = SCREEN_CHRMENUBASE + 2 * NUM_CHRMENU_ITEMS

SCREEN_DRAWINGHELP = SCREEN_CHRMENUBASE + 0
SCREEN_PALEDIT = SCREEN_CHRMENUBASE + 2
SCREEN_BLANKUNUSED = SCREEN_CHRMENUBASE + 4
SCREEN_RMDUPES = SCREEN_CHRMENUBASE + 6
SCREEN_DEFRAG = SCREEN_CHRMENUBASE + 8
SCREEN_SOON1 = SCREEN_CHRMENUEND - 2
.globalzp oam_used, nmis, tvSystem
.global draw_box

; paldetect.s
.global getTVSystem

; ppuclear.s
.global ppu_clear_nt, ppu_clear_oam, ppu_screen_on

; mmc1.s
.global setPRGBank, setMMC1BankMode

; pads.s
.global read_pads, autorepeat
.globalzp new_keys, cur_keys, das_keys

; chrram.s
.global load_chr_ram, load_x_rows_from_ay

; menus.s
.global title_screen, drawing_help_screen, comingsoon1_screen
.global puts_multiline, load_colorset_0

; chrpicker.s
.global chrpicker, draw_arrow, move_selected_tile_by_dpad, puthex
.globalzp selected_tile, selected_color, dirty

; ntedit.s
.global ntedit
.globalzp nt_x, nt_y, select_state

; chrutils.s
.global calculate_bg_tile_usage
.global blank_unused_tiles, remap_all_dupes, defrag_tiles
.global tilelist_A, tilelist_B
histo = tilelist_A

; paledit.s
.global paledit

; unpkb.s
.global unpb53_some, PB53_outbuf
.globalzp ciSrc, ciDst, ciBufStart, ciBufEnd

; tileedit.s
.global raster_4px

.endif
